tbb::internal::while_group_task< Body > Class Template Reference
Algorithms

For internal use only. More...

`#include <parallel_while.h>`

Inheritance diagram for tbb::internal::while_group_task< Body >:
Collaboration diagram for tbb::internal::while_group_task< Body >:

## Private Member Functions

| while_group_task (const Body &body)
task * | execute () __TBB_override
| Should be overridden by derived classes. More...

## Private Attributes

const Body & | my_body
size_t | size
Body::argument_type | my_arg [max_arg_size]

## Static Private Attributes

static const size_t | max_arg_size = 4

## Friends

template<typename Stream , typename Body_ >
class | while_task

## Additional Inherited Members

Public Types inherited from tbb::task
enum | state_type { executing , reexecute , ready , allocated , freed , recycle }
| Enumeration of task states that the scheduler considers. More...
typedef internal::affinity_id | affinity_id
| An id as used for specifying affinity. More...
Public Member Functions inherited from tbb::task
virtual | ~task ()
| Destructor. More...
internal::allocate_continuation_proxy & | allocate_continuation ()
| Returns proxy for overloaded new that allocates a continuation task of *this. More...
internal::allocate_child_proxy & | allocate_child ()
| Returns proxy for overloaded new that allocates a child task of *this. More...
void | recycle_as_continuation ()
| Change this to be a continuation of its former self. More...
void | recycle_as_safe_continuation ()
| Recommended to use, safe variant of recycle_as_continuation. More...
void | recycle_as_child_of (task &new_parent)
| Change this to be a child of new_parent. More...
void | recycle_to_reexecute ()
| Schedule this for reexecution after current execute() returns. More...
void | set_ref_count (int count)
| Set reference count. More...
void | increment_ref_count ()
| Atomically increment reference count. More...
int | add_ref_count (int count)
| Atomically adds to reference count and returns its new value. More...
int | decrement_ref_count ()
| Atomically decrement reference count and returns its new value. More...
void | spawn_and_wait_for_all (task &child)
| Similar to spawn followed by wait_for_all, but more efficient. More...
void __TBB_EXPORTED_METHOD | spawn_and_wait_for_all (task_list &list)
| Similar to spawn followed by wait_for_all, but more efficient. More...
void | wait_for_all ()
| Wait for reference count to become one, and set reference count to zero. More...
task * | parent () const
| task on whose behalf this task is working, or NULL if this is a root. More...
void | set_parent (task *p)
| sets parent task pointer to specified value More...
task_group_context * | context ()
| This method is deprecated and will be removed in the future. More...
task_group_context * | group ()
| Pointer to the task group descriptor. More...
bool | is_stolen_task () const
| True if task was stolen from the task pool of another thread. More...
bool | is_enqueued_task () const
| True if the task was enqueued. More...
state_type | state () const
| Current execution state. More...
int | ref_count () const
| The internal reference count. More...
bool __TBB_EXPORTED_METHOD | is_owned_by_current_thread () const
| Obsolete, and only retained for the sake of backward compatibility. Always returns true. More...
void | set_affinity (affinity_id id)
| Set affinity for this task. More...
affinity_id | affinity () const
| Current affinity of this task. More...
virtual void __TBB_EXPORTED_METHOD | note_affinity (affinity_id id)
| Invoked by scheduler to notify task that it ran on unexpected thread. More...
void __TBB_EXPORTED_METHOD | change_group (task_group_context &ctx)
| Moves this task from its current group into another one. More...
bool | cancel_group_execution ()
| Initiates cancellation of all tasks in this cancellation group and its subordinate groups. More...
bool | is_cancelled () const
| Returns true if the context has received cancellation request. More...
__TBB_DEPRECATED void | set_group_priority (priority_t p)
| Changes priority of the task group this task belongs to. More...
__TBB_DEPRECATED priority_t | group_priority () const
| Retrieves current priority of the task group this task belongs to. More...
Static Public Member Functions inherited from tbb::task
static internal::allocate_root_proxy | allocate_root ()
| Returns proxy for overloaded new that allocates a root task. More...
static internal::allocate_root_with_context_proxy | allocate_root (task_group_context &ctx)
| Returns proxy for overloaded new that allocates a root task associated with user supplied context. More...
static void | spawn_root_and_wait (task &root)
| Spawn task allocated by allocate_root, wait for it to complete, and deallocate it. More...
static void | spawn_root_and_wait (task_list &root_list)
| Spawn root tasks on list and wait for all of them to finish. More...
static void | enqueue (task &t)
| Enqueue task for starvation-resistant execution. More...
static void | enqueue (task &t, priority_t p)
| Enqueue task for starvation-resistant execution on the specified priority level. More...
static void | enqueue (task &t, task_arena &arena, priority_t p=priority_t(0))
| Enqueue task in task_arena. More...
static task &__TBB_EXPORTED_FUNC | self ()
| The innermost task being executed or destroyed by the current thread at the moment. More...
Protected Member Functions inherited from tbb::task
| task ()
| Default constructor. More...

## Detailed Description

### template<typename Body>
class tbb::internal::while_group_task< Body >

For internal use only.

Unpacks a block of iterations.

Definition at line 58 of file parallel_while.h.

## Constructor & Destructor Documentation

## while_group_task()

template<typename Body >

tbb::internal::while_group_task< Body >::while_group_task | ( | const Body & | body | ) |

inline private

Definition at line 63 of file parallel_while.h.

: my_body(body), size(0) {}
tbb::internal::while_group_task::size
size_t size
Definition: parallel_while.h:61
tbb::internal::while_group_task::my_body
const Body & my_body
Definition: parallel_while.h:60

## Member Function Documentation

## execute()

template<typename Body >

task* tbb::internal::while_group_task< Body >::execute | ( |  | ) |

inline private virtual

Should be overridden by derived classes.

Implements tbb::task.

Definition at line 64 of file parallel_while.h.

{
typedef while_iteration_task<Body> iteration_type;
__TBB_ASSERT( size>0, NULL );
task_list list;
task* t;
size_t k=0;
for(;;) {
t = new( allocate_child() ) iteration_type(my_arg[k],my_body);
if( ++k==size ) break;
list.push_back(*t);
}
set_ref_count(int(k+1));
spawn(list);
spawn_and_wait_for_all(*t);
return NULL;
}
__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165
tbb::internal::while_group_task::my_arg
Body::argument_type my_arg[max_arg_size]
Definition: parallel_while.h:62
tbb::task::allocate_child
internal::allocate_child_proxy & allocate_child()
Returns proxy for overloaded new that allocates a child task of *this.
Definition: task.h:681
tbb::task::task_list
friend class task_list
Definition: task.h:990
tbb::task::spawn_and_wait_for_all
void spawn_and_wait_for_all(task &child)
Similar to spawn followed by wait_for_all, but more efficient.
Definition: task.h:800
tbb::task::set_ref_count
void set_ref_count(int count)
Set reference count.
Definition: task.h:761
tbb::task::task
task()
Default constructor.
Definition: task.h:625

References __TBB_ASSERT, tbb::task::allocate_child(), tbb::internal::while_group_task< Body >::my_arg, tbb::internal::while_group_task< Body >::my_body, tbb::task_list::push_back(), tbb::task::set_ref_count(), tbb::internal::while_group_task< Body >::size, and tbb::task::spawn_and_wait_for_all().

Here is the call graph for this function:

## Friends And Related Function Documentation

## while_task

template<typename Body >
template<typename Stream , typename Body_ >

friend class while_task

friend

Definition at line 80 of file parallel_while.h.

## Member Data Documentation

## max_arg_size

template<typename Body >

const size_t tbb::internal::while_group_task< Body >::max_arg_size = 4

static private

Definition at line 59 of file parallel_while.h.

## my_arg

template<typename Body >

Body::argument_type tbb::internal::while_group_task< Body >::my_arg[max_arg_size]

private

Definition at line 62 of file parallel_while.h.

Referenced by tbb::internal::while_group_task< Body >::execute().

## my_body

template<typename Body >

const Body& tbb::internal::while_group_task< Body >::my_body

private

Definition at line 60 of file parallel_while.h.

Referenced by tbb::internal::while_group_task< Body >::execute().

## size

template<typename Body >

size_t tbb::internal::while_group_task< Body >::size

private

Definition at line 61 of file parallel_while.h.

Referenced by tbb::internal::while_group_task< Body >::execute().

The documentation for this class was generated from the following file:

- parallel_while.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.